/* Simple Server Shutdown v1.0
*  ===========================
*  Description
*  -----------
*  This plugin will immediately shut down a dedicated server by issuing a
*  simple server RCON command.
*
*  The plugin notifies all of the current players on the server with a 20
*  second and a 15 second alert notification, and then with 10 second countdown
*  notification messages (complete with audible sound effects) announcing the
*  server shutdown.
*
*  RCON Command
*  ------------
*  simple_server_shutdown - Immediately shuts down the server after 20 seconds,
*                           with a 10 second countdown.
*
*  Additional Notes
*  ----------------
*  Note that this plugin is quite handy when invoked using PenDragon's "Task
*  Scheduler v0.2" (http://forums.alliedmods.net/showthread.php?t=1263) to
*  automatically shut down and restart a dedicated server at a specific time of
*  day (e.g. amx_task 05:09 "simple_server_shutdown" t).
*
*
*  ENJOY!
*
*  Rich Weeds Nagel
*  October 10, 2013
*
*  AIM: RichFNagel
*  ICQ: 565228098 / RichFNagel
*  Twitter: @RFNagel
*
*  richnagel@centurylink.net
*  richnagel@simpilot.net
*  rfnagel@juno.com
*
*  http://www.richnagel.net
*  http://www.simpilot.net/~richnagel
*  http://jasonwilliams400com.startlogic.com/snor/
*  http://jasonwilliams400com.startlogic.com/snor/weeds/
*  http://jasonwilliams400com.startlogic.com/snor/weeds/Counter_Strike/
*  http://jasonwilliams400com.startlogic.com/snor/weeds/Day_of_Defeat/
*  http://tinyurl.com/TumbleWeedsCSCZDODServerStatus
*  http://www.facebook.com/RFNagel
*  http://www.facebook.com/profile.php?id=1164518241
*  http://steamcommunity.com/id/RichNagel
*  http://steamcommunity.com/groups/SwampBuzzardsClan
*  http://www.youtube.com/RFNagel
*/

#include <amxmodx>
#include <amxmisc>

public plugin_init() {
	register_plugin("Simple Server Shutdown","1.0","Rich Weeds Nagel")
	register_concmd("simple_server_shutdown","simpleservershutdown",ADMIN_IMMUNITY," - Immediately shuts down the server after 20 seconds, with a 10 second countdown.")
}

public simpleservershutdown(id) {
	if (!(get_user_flags(id)&ADMIN_LEVEL_A)) {
		console_print(id,"[AMXModX] You do not have access to this command!")
		return PLUGIN_HANDLED
	}
	set_task(0.0,"alert_twenty")
	set_task(5.0,"alert_fifteen")
	set_task(10.0,"ten")
	set_task(11.0,"nine")
	set_task(12.0,"eight")
	set_task(13.0,"seven")
	set_task(14.0,"six")
	set_task(15.0,"five")
	set_task(16.0,"four")
	set_task(17.0,"three")
	set_task(18.0,"two")
	set_task(19.0,"one")
	set_task(20.0,"zero")
	set_task(25.0,"shutdown_server")

	return PLUGIN_HANDLED
}

public alert_twenty() {
	client_print(0,print_chat,"ATTENTION: This server will be shut down in 20 seconds for temporary maintenance!")
	server_print("ATTENTION: This server will be shut down in 20 seconds for temporary maintenance!")
	client_cmd(0,"spk ^"fvox/alert.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"ATTENTION: This server will be shut down in 20 seconds for temporary maintenance!")
}

public alert_fifteen() {
	client_print(0,print_chat,"ATTENTION: This server will be shut down in 15 seconds for temporary maintenance!")
	server_print("ATTENTION: This server will be shut down in 15 seconds for temporary maintenance!")
	client_cmd(0,"spk ^"fvox/alert.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"ATTENTION: This server will be shut down in 15 seconds for temporary maintenance!")
}

public ten() {
	client_print(0,print_chat,"Server shutdown in 10 seconds...")
	server_print("Server shutdown in 10 seconds...")
	client_cmd(0,"spk ^"fvox/ten.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"Server shutdown in 10 seconds...")
}

public nine() {
	client_print(0,print_chat,"Server shutdown in 9 seconds...")
	server_print("Server shutdown in 9 seconds...")
	client_cmd(0,"spk ^"fvox/nine.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"Server shutdown in 9 seconds...")
}

public eight() {
	client_print(0,print_chat,"Server shutdown in 8 seconds...")
	server_print("Server shutdown in 8 seconds...")
	client_cmd(0,"spk ^"fvox/eight.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"Server shutdown in 8 seconds...")
}

public seven() {
	client_print(0,print_chat,"Server shutdown in 7 seconds...")
	server_print("Server shutdown in 7 seconds...")
	client_cmd(0,"spk ^"fvox/seven.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"Server shutdown in 7 seconds...")
}

public six() {
	client_print(0,print_chat,"Server shutdown in 6 seconds...")
	server_print("Server shutdown in 6 seconds...")
	client_cmd(0,"spk ^"fvox/six.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"Server shutdown in 6 seconds...")
}

public five() {
	client_print(0,print_chat,"Server shutdown in 5 seconds...")
	server_print("Server shutdown in 5 seconds...")
	client_cmd(0,"spk ^"fvox/five.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"Server shutdown in 5 seconds...")
}

public four() {
	client_print(0,print_chat,"Server shutdown in 4 seconds...")
	server_print("Server shutdown in 4 seconds...")
	client_cmd(0,"spk ^"fvox/four.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"Server shutdown in 4 seconds...")
}

public three() {
	client_print(0,print_chat,"Server shutdown in 3 seconds...")
	server_print("Server shutdown in 3 seconds...")
	client_cmd(0,"spk ^"fvox/three.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"Server shutdown in 3 seconds...")
}

public two() {
	client_print(0,print_chat,"Server shutdown in 2 seconds...")
	server_print("Server shutdown in 2 seconds...")
	client_cmd(0,"spk ^"fvox/two.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"Server shutdown in 2 seconds...")
}

public one() {
	client_print(0,print_chat,"Server shutdown in 1 second...")
	server_print("Server shutdown in 1 second...")
	client_cmd(0,"spk ^"fvox/one.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"Server shutdown in 1 second...")
}

public zero() {
	client_print(0,print_chat,"This server is now shutting down for temporary maintenance!")
	client_print(0,print_chat,"Please rejoin the server again after a few minutes, Goodbye!")
	server_print("This server is now shutting down for temporary maintenance!")
	server_print("Please rejoin the server again after a few minutes, Goodbye!")
	client_cmd(0,"spk ^"fvox/safe_day.wav^"")
	set_hudmessage (255,0,0,-1.0,0.35,0,6.0,12.0,0.1,0.2,1)
	show_hudmessage(0,"This server is now shutting down for temporary maintenance! Please rejoin the server again after a few minutes, Goodbye!")
}

public shutdown_server() {
	server_cmd("quit")
}
